<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 * @property mixed description
 * @property mixed statistics
 */
class CourseRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        if(Auth::user()->hasModule('courses'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'images.*' => 'required',
            'unit_id' => 'required|array',
            'price' => 'required',
            'hours' => 'required',
            'start_at' => 'required|date',
            'end_at' => 'required|date',
            'image' => 'required',
            'instructor' => 'required',
//            'exam' => 'sometimes',
//            'certified' => 'sometimes',
//            'level_id' => 'required',
            'category_id' => 'required',
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required',
                'description_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('courses');
        $local = getCurrentLocale();
        $attributes=[
            'images.*' => metaFields('courses', 'image', $local),
            'unit_id.*' => metaFields('unit_id', 'unit_id', $local),
            'price' => metaFields('courses', 'price', $local),
            'hours' => metaFields('courses', 'hours', $local),
            'start_at' => metaFields('courses', 'start_at', $local),
            'end_at' => metaFields('courses', 'end_at', $local),
            'image' => metaFields('courses', 'schedule', $local),
            'instructor' => metaFields('courses', 'instructor', $local),
//            'exam' => metaFields('courses', 'exam', $local),
//            'certified' => metaFields('courses', 'certified', $local),
//            'level_id' => metaFields('courses', 'level_id', $local),
            'category_id' => metaFields('courses', 'category_id', $local),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => $field[$lang->local]['name'] ?? __('courses.name'),
                'description_'.$lang->local =>$field[$lang->local]['description'] ?? __('courses.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
